"use client"

import Share from '@components/core/Share';
import services from '@helpers/services.json';
import { useEffect, useState } from "react";

import metadata from '@metadata.json';
import { Statics } from '@helpers/Statics';

export default async function SharePages(props) {


		async function getfetch (crest) {
			const response = await fetch(metadata.hostname+'api/img?url='+crest);
			const result = await response.json();
			return result;
		};

		async function finishedCanvas(id) {

				var canvas   = document.getElementById(id);
				var ctx      = canvas.getContext('2d');
				var home     = props.data.homeTeam.shortName ?? "X";
				var away     = props.data.awayTeam.shortName ?? "X";
				var site     = metadata.shorturl;
				var time     = Statics.getTimeFromUTC(props.data.utcDate) ?? "X";
				var matchday = "matchday : "+props.data.matchday ?? "X";
				var status   = props.data.status ?? "X";

				canvas.width = 700;
				canvas.height = 450;

				ctx.fillStyle = '#adffcc';
				ctx.fillRect(0, 0, canvas.width, canvas.height);
				
				ctx.font = 'bold 36px Sans-Serif';
				ctx.fillStyle = '#000';
				ctx.fillText(home, (canvas.width/4)-home.length*12, 220);
				ctx.fillText(away, (canvas.width/4)*3-away.length*9, 220);

				ctx.fillStyle = 'white';
				try{
					ctx.roundRect(100, 45, 120, 122, 10);
				} catch (err) {
					ctx.rect(100, 45, 120, 122);
				}
				ctx.fill();
				
				ctx.fillStyle = 'white';
				try{
					ctx.roundRect(460, 45, 120, 122, 10);
				} catch (err) {
					ctx.rect(460, 45, 120, 122);
				}
				ctx.fill();


				ctx.fillStyle = 'white';
				try{
					ctx.roundRect(0, canvas.height-30, canvas.width, 30, 0);
				} catch (err) {
					ctx.rect(0, canvas.height-30, canvas.width, 30);
				}
				ctx.fill();


				ctx.fillStyle = 'white';
				try{
					ctx.roundRect(((canvas.width/2)-time.length*5)-5, (canvas.height/2)+50, (time.length*10)+10, 30, 10);
				} catch (err) {
					ctx.rect(((canvas.width/2)-time.length*5)-5, (canvas.height/2)+50, (time.length*10)+10, 30);
				}
				ctx.fill();

				ctx.fillStyle = 'white';
				try{
					ctx.roundRect(((canvas.width / 2)-(matchday.length*5))-5, ( canvas.height / 2 )+90, (matchday.length * 10)+10, 30, 10);
				} catch (err) {
					ctx.rect(((canvas.width/2)-matchday.length*5)-5, (canvas.height/2)+90, (matchday.length*10)+10, 30);
				}
				ctx.fill();

				ctx.fillStyle = 'white';
				try{
					ctx.roundRect(((canvas.width/2)-status.length*5)-5, (canvas.height/2)+130, (status.length*10)+10, 30, 10);
				} catch (err) {
					ctx.rect(((canvas.width/2)-status.length*5)-5, (canvas.height/2)+130, (status.length*10)+10, 30);
				}
				ctx.fill();

				ctx.font = 'bold 20px Sans-Serif';  
				ctx.fillStyle = '#000';
				ctx.fillText(status, (canvas.width/2)-status.length*5, (canvas.height/2)+150, status.length*10);

				ctx.font = 'bold 20px Sans-Serif';  
				ctx.fillStyle = '#000';
				ctx.fillText(matchday, (canvas.width/2)-matchday.length*5, (canvas.height/2)+110, matchday.length*10);

				ctx.font = 'bold 20px Sans-Serif';  
				ctx.fillStyle = '#000';
				ctx.fillText(time, (canvas.width/2)-time.length*5, (canvas.height/2)+70, time.length*10);

				ctx.font = 'bold 20px Sans-Serif';  
				ctx.fillStyle = '#000';
				ctx.fillText("generate your own from "+site, 10, canvas.height-9);


				let image2 = new Image();
				image2.setAttribute('Access-Control-Allow-Origin', '*');
				image2.setAttribute('Access-Control-Allow-Headers', 'Origin, X-Requested-With, Content-Type, Accept');
				image2.crossOrigin = "anonymous";
				image2.onload = function() {
					ctx.drawImage(image2, 470, 60, 100, 100);
				};
				await getfetch(props.data.awayTeam.crest)
					.then((data) => {
						let type = 'png';
						if(props.data.awayTeam.crest.split(".")[props.data.awayTeam.crest.split(".").length-1] === 'svg'){
							type='svg+xml'
						}
						image2.src= 'data:image/'+type+';base64,' + data;
					});


				let image1 = new Image();
				image1.setAttribute('Access-Control-Allow-Origin', '*');
				image1.setAttribute('Access-Control-Allow-Headers', 'Origin, X-Requested-With, Content-Type, Accept');
				image1.crossOrigin = "anonymous";
				image1.onload = function () {
					ctx.drawImage(image1, 110, 60, 100, 100);
				};
				await getfetch(props.data.homeTeam.crest)
					.then((dd) => {
						let type = 'png';
						if(props.data.homeTeam.crest.split(".")[props.data.homeTeam.crest.split(".").length-1] === 'svg'){
							type='svg+xml'
						}
						image1.src= 'data:image/'+type+';base64,' + dd;
					});


				if (props.data.score?.fullTime?.away || props.data.score?.fullTime?.away==0) {
					ctx.font = 'bold 90px Sans-Serif';  
					ctx.fillStyle = '#082449';
					ctx.fillText(props.data.score.fullTime.home, 120, 320);
					ctx.fillText(props.data.score.fullTime.away, 490, 320); 
				}
				
				setTimeout(function () {
					console.log("After 2 seconds");
					xdownload(id);
				}, 2000);
		}

					const xdownload = (id) => {
							console.log('finish rendering');
							const canvas = document.getElementById(id);
							const dataURL = canvas.toDataURL('image/png');
							const a = document.createElement('a');
							a.href = dataURL;
							a.download = metadata.name+`-image-matchdaycard.png`;
							a.click();
					}

		return (
						<div className="container m-auto sm:mx-auto mx-2 flex flex-row flex-wrap items-center justify-center content-center">
								<div className="w-full m-2 p-4 rounded-lg bg-primary flex flex-col items-center justify-center content-center">
									<button onClick={()=>document.getElementById('match-modal').showModal()} className="btn bg-accent p-4 rounded-lg flex flex-col items-center justify-center h-auto w-full h-[11.5em] max-h-[11.5em] min-h-[11.5em] content-center">
										<svg className="w-[5em] min-w-[5em] max-w-[5em]" fill="#1d3d4d" viewBox="0 0 24 24" id="share-alt" data-name="Flat Color" xmlns="http://www.w3.org/2000/svg"><g id="SVGRepo_bgCarrier" stroke-width="0"></g><g id="SVGRepo_tracerCarrier" stroke-linecap="round" stroke-linejoin="round"></g><g id="SVGRepo_iconCarrier"><path id="secondary" d="M21.62,6.22l-5-4a1,1,0,0,0-1.05-.12A1,1,0,0,0,15,3V4.19a9.79,9.79,0,0,0-7,7.65,1,1,0,0,0,.62,1.09A1,1,0,0,0,9,13a1,1,0,0,0,.83-.45C11,10.78,13.58,10.24,15,10.07V11a1,1,0,0,0,.57.9,1,1,0,0,0,1.05-.12l5-4a1,1,0,0,0,0-1.56Z" style={{fill:"#2ca9bc"}}></path><path id="primary" d="M17.25,12.56A2,2,0,0,1,16,13a1.94,1.94,0,0,1-.86-.2A2,2,0,0,1,14,11.25a5.44,5.44,0,0,0-3.36,1.86A2,2,0,0,1,9,14a2.07,2.07,0,0,1-.74-.14A2,2,0,0,1,7,11.67,11.13,11.13,0,0,1,12.7,4H4A2,2,0,0,0,2,6V19a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V9a.83.83,0,0,0,0-.22Z" style={{fill:"#1d3d4d"}}></path></g></svg>
										<span className="font-bold text-2xl font-extrabold">Share Card</span>
									</button>
									<dialog id="match-modal" className="modal modal-bottom sm:modal-middle">
										<div className="modal-box lg:max-w-[66%]">
											<Share title={`${props.teams[0]} vs ${props.teams[1]} - ${props.league} - matchday ${props.matchday} - ${process.env.NAME} `} description={`${props.teams[0]} vs ${props.teams[1]} - ${props.league} - matchday ${props.matchday} - ${metadata.name} `}  url={metadata.hostname+props.code+"/"+props.id} data={JSON.stringify(services)} />
											<div className="modal-action btn sticky bottom-0 bg-black p-4 rounded-lg h-auto w-[90%] m-auto mt-[1em]">
												<form method="dialog">
													<div onClick={()=>{navigator.clipboard.writeText(services.url)}} className="btn mr-4">Copy</div>
													<button className="btn">Close</button>
												</form>
											</div>
										</div>
									</dialog>
								</div>
										<div className="w-full m-2 p-4 rounded-lg bg-primary flex flex-col items-center justify-center content-center">
											<button onClick={async()=>{await finishedCanvas(props.id+"-canvas")}} className="btn bg-accent p-4 rounded-lg flex flex-col items-center justify-center h-auto w-full h-[11.5em] max-h-[11.5em] min-h-[11.5em] content-center">
												<svg
													className="w-[5em] min-w-[5em] max-w-[5em]" 
													xmlns="http://www.w3.org/2000/svg"
													fill="#000"
													data-name="Flat Color"
													viewBox="0 0 24 24"
												>
													<g>
														<path
															fill="#2ca9bc"
															d="M19 22H5a2 2 0 01-2-2v-3a1 1 0 012 0v3h14v-3a1 1 0 012 0v3a2 2 0 01-2 2z"
														></path>
														<path
															fill="#1d3d4d"
															d="M19.11 9.91l-1.3-1.52a2 2 0 00-1.37-.69 2 2 0 00-1.44.46V3a1 1 0 00-1-1h-4a1 1 0 00-1 1v5.16a2 2 0 00-1.44-.46 2 2 0 00-1.37.69l-1.3 1.52a2 2 0 00.22 2.82l5.59 4.79a2 2 0 002.6 0l5.59-4.79a2 2 0 00.22-2.82z"
														></path>
													</g>
												</svg>
												<span className="font-bold text-2xl font-extrabold">Download</span>
				  						</button>
				  					</div>
				  					<canvas id={props.id+"-canvas"} style={{display:"none"}}></canvas>
      			</div>
    );
}
